


package de.frank_rahn.xmlns.types.cixs.cbk010.output._1.bind;

import com.legstar.coxb.ICobolBinding;
import com.legstar.coxb.common.CComplexBinding;
import com.legstar.coxb.ICobolStringBinding;
import com.legstar.coxb.CobolBindingFactory;
import com.legstar.coxb.ICobolBindingFactory;
import com.legstar.coxb.ICobolBinaryBinding;
import com.legstar.coxb.ICobolComplexBinding;
import com.legstar.coxb.host.HostException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import de.frank_rahn.xmlns.types.cixs.cbk010.output._1.Result;
import de.frank_rahn.xmlns.types.cixs.cbk010.output._1.ObjectFactory;

/**
 * LegStar Binding for Complex element :
 *   Result.
 * 
 * This class was generated by LegStar Binding generator.
 */
public class ResultBinding 
             extends CComplexBinding {

    /** Value object to which this cobol complex element is bound. */
    private Result mValueObject;
  
    /** Indicates that the associated Value object just came from the constructor
     * and doesn't need to be recreated. */
    private boolean mUnusedValueObject = false;
    
    /** Maximum host bytes size for this complex object. */
    private static final int BYTE_LENGTH = 78;
    
    /** Child bound to value object property Fehlercode(String). */
    public ICobolStringBinding _fehlercode;
    /** Child bound to value object property Fehlertext(String). */
    public ICobolStringBinding _fehlertext;
    /** Child bound to value object property Sqlcode(Integer). */
    public ICobolBinaryBinding _sqlcode;
            
    /** Logger. */
    private final Log _log = LogFactory.getLog(getClass());

    /** Binding factory. */
    private static final ICobolBindingFactory BF
        = CobolBindingFactory.getBindingFactory();
 
    /** Static reference to Value object factory to be used as default. */
    private static final ObjectFactory JF = new ObjectFactory();
    
    /** Current Value object factory (Defaults to the static one but can be
     *  changed). */
    private ObjectFactory mValueObjectFactory = JF;
    
    /**
     * Constructor for a root Complex element without a bound Value object.
     */
    public ResultBinding() {
        this(null);
    }

    /**
     * Constructor for a root Complex element with a bound Value object.
     * 
     * @param valueObject the concrete Value object instance bound to this
     *        complex element
     */
    public ResultBinding(
            final Result valueObject) {
        this("", "", null, valueObject);
    }

    /**
    * Constructor for a Complex element as a child of another element and
    * an associated Value object.
    * 
    * @param bindingName the identifier for this binding
    * @param fieldName field name in parent Value object
    * @param valueObject the concrete Value object instance bound to this
    *        complex element
    * @param parentBinding a reference to the parent binding
    */
    public ResultBinding(
            final String bindingName,
            final String fieldName,
            final ICobolComplexBinding parentBinding,
            final Result valueObject) {
        
        super(bindingName, fieldName, Result.class, null, parentBinding);
        mValueObject = valueObject;
        if (mValueObject != null) {
            mUnusedValueObject = true;
        }
        initChildren();
        setByteLength(BYTE_LENGTH);
    }

    /** Creates a binding property for each child. */
    private void initChildren() {
        if (_log.isDebugEnabled()) {
            _log.debug("Initializing started");
        }
        /* Create binding children instances */

        _fehlercode = BF.createStringBinding("Fehlercode",
               "Fehlercode", String.class, this);
        _fehlercode.setCobolName("FEHLERCODE");
        _fehlercode.setByteLength(2);
        _fehlertext = BF.createStringBinding("Fehlertext",
               "Fehlertext", String.class, this);
        _fehlertext.setCobolName("FEHLERTEXT");
        _fehlertext.setByteLength(72);
        _sqlcode = BF.createBinaryBinding("Sqlcode",
               "Sqlcode", Integer.class, this);
        _sqlcode.setCobolName("SQLCODE");
        _sqlcode.setByteLength(4);
        _sqlcode.setTotalDigits(5);
        _sqlcode.setIsSigned(true);

        /* Add children to children list */
        getChildrenList().add(_fehlercode);
        getChildrenList().add(_fehlertext);
        getChildrenList().add(_sqlcode);
 
        if (_log.isDebugEnabled()) {
            _log.debug("Initializing successful");
        }
    }
    
    /** {@inheritDoc} */
    public void createValueObject() throws HostException {
        /* Since this complex binding has a constructor that takes a
         * Value object, we might already have a Value object that
         * was not used yet. */
        if (mUnusedValueObject && mValueObject != null) {
            mUnusedValueObject = false;
            return;
        }
        mValueObject = mValueObjectFactory.createResult();
    }

    /** {@inheritDoc} */
    public void setChildrenValues() throws HostException {

         /* Make sure there is an associated Value object*/
        if (mValueObject == null) {
            createValueObject();
        }
        /* Get Value object property _fehlercode */
        if (_log.isDebugEnabled()) {
            _log.debug("Getting value from Value object property "
                    + "_fehlercode"
                    + " value=" + mValueObject.getFehlercode());
        }
        _fehlercode.setObjectValue(mValueObject.getFehlercode());
        /* Get Value object property _fehlertext */
        if (_log.isDebugEnabled()) {
            _log.debug("Getting value from Value object property "
                    + "_fehlertext"
                    + " value=" + mValueObject.getFehlertext());
        }
        _fehlertext.setObjectValue(mValueObject.getFehlertext());
        /* Get Value object property _sqlcode */
        if (_log.isDebugEnabled()) {
            _log.debug("Getting value from Value object property "
                    + "_sqlcode"
                    + " value=" + mValueObject.getSqlcode());
        }
        _sqlcode.setObjectValue(mValueObject.getSqlcode());
     }

    /** {@inheritDoc} */
    public void setPropertyValue(final int index) throws HostException {
 
        ICobolBinding child = getChildrenList().get(index);
        
       /* Children that are not bound to a value object are ignored.
        * This includes Choices and dynamically generated counters
        * for instance.  */
        if (!child.isBound()) {
            return;
        }
        
        /* Set the Value object property value from binding object */
        Object bindingValue = null;
        switch (index) {
        case 0:
            bindingValue = child.getObjectValue(String.class);
            mValueObject.setFehlercode((String) bindingValue);
            break;
        case 1:
            bindingValue = child.getObjectValue(String.class);
            mValueObject.setFehlertext((String) bindingValue);
            break;
        case 2:
            bindingValue = child.getObjectValue(Integer.class);
            mValueObject.setSqlcode((Integer) bindingValue);
            break;
         default:
            break;
        }
        if (_log.isDebugEnabled()) {
            _log.debug("Setting value of Value object property "
                    + child.getJaxbName()
                    + " value=" + bindingValue);
        }
    }

    /** {@inheritDoc} */
    public Object getObjectValue(
            final Class < ? > type) throws HostException {
        if (type.equals(Result.class)) {
            return mValueObject;
        } else {
            throw new HostException("Attempt to get binding " + getBindingName()
                    + " as an incompatible type " + type);
        }
    }

    /** {@inheritDoc} */
    public void setObjectValue(
            final Object bindingValue) throws HostException {
        if (bindingValue == null) {
            mValueObject = null;
            return;
        }
        if (bindingValue.getClass().equals(Result.class)) {
            mValueObject = (Result) bindingValue;
        } else {
            throw new HostException("Attempt to set binding " + getBindingName()
                    + " from an incompatible value " + bindingValue);
        }
    }

    /**
     * @return the java object factory for objects creation
     */
    public ObjectFactory getObjectFactory() {
        return mValueObjectFactory;
    }

    /**
     * @param valueObjectFactory the java object factory for objects creation 
     */
    public void setObjectFactory(final Object valueObjectFactory) {
        mValueObjectFactory = (ObjectFactory) valueObjectFactory;
    }

    /** {@inheritDoc} */
    public boolean isSet() {
        return (mValueObject != null);
    }

    /**
     * @return the bound Value object
     */
    public Result getResult() {
        return mValueObject;
    }
    
    /**
     * The COBOL complex element maximum length in bytes.
     * 
     * @return COBOL complex element maximum length in bytes
     */
    public int getByteLength() {
        return BYTE_LENGTH;
    }
}

